////////////////////////////////////////////////////////////
//  t\Cu@for PIC18Fxxxx Ver 11.0 20110808
//  ȉ̋@\
//    LCD_int()     ----- 
//    LCD_cmd(cmd)  ----- R}ho
//    LCD_dat(chr)  ----- P\
//    LCD_str(*str) ---- \
//    LCD_ROMstr(*str) -- ROM\
//    LCD_posyx(y,x) ---- J[\ʒuwAs yAʒu x
//    LCD_clr()      ----- S
//    LCD_icon_on(icn);--- wACRON
//    LCD_icon_off(icn);-- wACROFF
//    LCD_icon_clrf();---- SACROFF
////////////////////////////////////////////////////////////

#include <p18cxxx.h>
#include <delays.h>
#include <i2c.h>        //I2C֐
#include "L_i2cLCD.h"

//-------- P\
void LCD_dat(char chr){
	EEByteWrite(0x7C, 0x40, chr);
	Delay_50uS;		// 50sec
}
//-------- R}ho
void LCD_cmd(char cmd){
	EEByteWrite(0x7C, 0x00, cmd);
	if(cmd & 0xFC)   // ʂUrbgɂP閽
		Delay_50uS;  // 50usec
	else
		Delay_2mS;   // 2msec@ClearHomeR}h
}
//-------- S
void LCD_clr(void){
	LCD_cmd(0x01);		//ClearR}ho
}
//-------- J[\ʒuw
void LCD_posyx(char ypos, char xpos){
	unsigned char pcode;
	switch(ypos & 0x03){	
		case 0:	pcode=0x80;break;
		case 1:	pcode=0xC0;break;
		case 2:	pcode=0x94;break;
		case 3:	pcode=0xD4;break;
	}
	LCD_cmd(pcode += xpos);
}
//-------- o
void LCD_str(char *str){
	EEPageWrite(0x7C, 0x40, str);
}
//-------- Rom o
void LCD_ROMstr(rom const char *str){
	while(*str)			//̏I(00)܂Ōp
		LCD_dat(*str++);	//o͂|C^{P
}
//-------- 
void LCD_int(void){
    OpenI2C(MASTER, SLEW_ON);       //I2C}X^[[hw
    SSPADD = 9;                     //Board Rate 100kHz (4MHzNbNj
//    SSPADD = 0x1D;                  //Board Rate 400kHz (48MHzNbNj
	Delay_100mS;
	LCD_cmd(0x38);		// 8bit 2s \߃[h
	LCD_cmd(0x39);		// 8bit 2s g߃[h
	LCD_cmd(0x14);		// OSC  BIAS ݒ1/5
						// RgXgݒ 
	LCD_cmd(0x70 + (CONTRAST & 0x0F));
	LCD_cmd(0x5C + (CONTRAST >> 4));
	LCD_cmd(0x6B);		// Ffollwer
	Delay_100mS;
	Delay_100mS;
	LCD_cmd(0x38);		// \߃[h 
	LCD_cmd(0x0C);		// Display On 
	LCD_cmd(0x01);		// Clear Display 
}
//-- wACR ON
void LCD_icon_on(int icn){
	LCD_cmd(0x39);			// g߃[h 
	LCD_cmd(icn >> 8);		// Icon AhX 
	LCD_dat(icn & 0xFF);	// Icon rbg <ON>
	LCD_cmd(0x38);			// \߃[h 
}
//-- wACR OFF
void LCD_icon_off(int icn){
	LCD_cmd(0x39);			// g߃[h 
	LCD_cmd(icn >> 8);		// Icon AhX 
	LCD_dat(0x00);			// Icon rbg <OFF>
	LCD_cmd(0x38);			// \߃[h 
}
//-- SACR OFF
void LCD_icon_clr(void){
	unsigned char icn = 0x40;
	LCD_cmd(0x39);			// g߃[h 
	while(icn <= 0x4F){
		LCD_cmd(icn++);		// Icon AhX 
		LCD_dat(0x00);		// Icon rbg <OFF>
	}
	LCD_cmd(0x38);			// \߃[h 
}

